hdu 1011 Starship Troopers(树形DP入门)

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 17498    Accepted Submission(s): 4644

Problem Description

You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern‘s structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.

Input

The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1‘s.

Output

For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.

Sample Input

5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5
1 1
20 7
-1 -1

Sample Output

50
7

Author

XU, Chuan

Source

ZJCPC2004

Recommend

JGShining   |   We have carefully selected several similar problems for you:  1561 2415 1114 2546 2159

/*
这个必须要用无向图,重判的时候用visit数组标记
*/
#include<stdio.h>
#include<iostream>
#include<string.h>
#include<vector>
#define N 110
using namespace std;
int n,m;
vector<int> v[N];//用来存放数的
int dp[N][N];//dp[i][j]表示在第i个结点的时候,用j个士兵能获得多少幽灵
int f[N];//用来找树根的
bool visit[N];//记录当前结点走没走过
struct node
{
    int p,q;//妖怪的数量,想要的有幽灵的数量
}fr[N];
void dfs(int root)
{
    visit[root]=true;
    int num=(fr[root].p+19)/20;//当前房间最少需要
    for(int i=num;i<=m;i++)
            dp[root][i]=fr[root].q;//只要是超过了num个士兵都是q个人
    //cout<<num<<endl;
    for(int i=0;i<v[root].size();i++)
    {
        int next=v[root][i];//下一个房间
        //cout<<"next="<<next<<endl;
        //cout<<"visit[next]="<<visit[next]<<endl;
        if(visit[next])
        {
            //cout<<"visit[next]="<<visit[next]<<endl;
            continue;//下一步走过了就跳过
        }
        dfs(next);
        //cout<<"ok"<<endl;
        //对dp数组进行初始化
        for(int j=m;j>=num;j--)//背包枚举
        {
            for(int k=1;k+j<=m;k++)
            {
                if(dp[next][k])
                    dp[root][j+k]=max(dp[root][j+k],dp[root][j]+dp[next][k]);
            }
        }
    }
}
int main()
{
    //freopen("in.txt","r",stdin);
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        if(n==-1&&m==-1)
            break;
        memset(visit,false,sizeof visit);
        memset(dp,0,sizeof dp);
        v[0].clear();
        for(int i=1;i<=n;i++)
        {
            scanf("%d%d",&fr[i].p,&fr[i].q);
            //cout<<fr[i].p<<" "<<fr[i].q<<endl;
            //f[i]=i;
            v[i].clear();
        }
        v[n+1].clear();
        int a,b;
        for(int i=1;i<n;i++)
        {
            scanf("%d%d",&a,&b);
            //cout<<a<<" "<<b<<endl;
            v[a].push_back(b);
            v[b].push_back(a);
            f[b]=a;
        }
        //for(int i=1;i<=n;i++)
        //    cout<<"i="<<i<<" "<<v[i].size()<<endl;
        if(m==0)
        {
            printf("0\n");
        }
        else
        {
            //int root=1;
            //while(root!=f[root]) root=f[root];//找根
            //cout<<"root="<<root<<endl;
            dfs(1);
            printf("%d\n",dp[1][m]);

        }
    }
    return 0;
}
时间: 2024-12-05 05:08:15

hdu 1011 Starship Troopers(树形DP入门)的相关文章

HDU 1011 Starship Troopers(树形DP)

Starship Troopers Time Limit : 10000/5000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 62   Accepted Submission(s) : 12 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description You, the leader of

HDU 1011 Starship Troopers 树形DP 有坑点

本来是一道很水的树形DP题 设dp[i][j]表示,带着j个人去攻打以节点i为根的子树的最大收益 结果wa了一整晚 原因: 坑点1: 即使这个节点里面没有守卫,你如果想获得这个节点的收益,你还是必须派一个人去这个节点,不然谁帮你去拿收益? 坑点2: 题目说是从节点1开始攻打,然后我就以为给出的数据都是以1为根节点的,就没有加双向边 不过, 最后我加了双向边,然后还是wa了 又找了很久,最后发现是前向星的数组开小了 注意:数组开小了可能会返回wa,tle,re等等等等 1 #include<cst

hdu 1011 Starship Troopers 树形背包

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1011 题意:有n个洞,每个洞有若干虫子和脑子,洞之间相连形成一棵树.你有m个士兵,一个士兵可以打10只虫子,士兵留下后就不能走了.从一号洞开始打,求获得最多的脑子. 树形背包.如果你在某一个洞里,有m个士兵.你可以选择派遣k个士兵去攻打与洞相连的某个子树.可以先用递归算出子树的情况.这类似于背包九讲的泛化背包. 定义 考虑这样一种物品,它并没有固定的费用和价值,而是它的价值随着你分配给它的费用而变化

hdu 1011 Starship Troopers 树dp

题目大意是有n个房间组成一棵树,你有m个士兵,从1号房间开始让士兵向相邻的房间出发,每个房间里有一个代价,代价是值/20个士兵, 同时有一个价值,问你花费这m个士兵可以得到的最大价值是多少 定义dp[i][j]表示根结点为i时,用掉j个士兵获得的最大possible. dp[i][j] = max(dp[i][j], dp[i][j-k] + dp[son[i]][k]); #include <cstdio> #include <cstring> #include <algo

hdu 1011 Starship Troopers (依赖背包 树形dp)

题目: 链接:点击打开链接 题意: n个房间组成一棵树,你有m个战队,从1号房间开始依次clear每个房间,在每个房间需要花费的战队个数是bugs/20,得到的价值是the possibility of capturing a brain,求最大的价值. 算法: 树形dp,有依赖的背包问题.(依次clear每个房间) 思路: 状态转移dp[i][j]表示根结点为i时(房间i)花费j个战队能够得到的最大价值(捕捉到一个brain最大的可能值).递归求出每个根结点处的最大值,最后dp[1][m]就是

HDU 1011 Starship Troopers(树形dp+背包)

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 13109    Accepted Submission(s): 3562 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of

树形dp/hdu 1011 Starship Troopers

题意 有n个房子,1号为起点房子.每个房子里会消耗一定的士兵来获取一定的价值.现在有m个士兵,求问可以获得的最大价值 注意:走过的房子不能再走 注意2:若要消灭这个房子的bugs,必须全部消灭 分析 典型的树形dp,01背包,因为每个房子里要么全杀死bugs,要么一个不动,只有取或不取两种状态 设f[i][j]表示以i为根节点,消耗j个士兵所能获得的最大价值 则f[i][j]=max(f[son[i]][k] + f[i][j-k]); 答案为f[1][m] Accepted Code 1 /*

hdu 1011 Starship Troopers DP

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11929    Accepted Submission(s): 3295 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of

hdu_1011(Starship Troopers) 树形dp

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=1011 题意:打洞洞收集脑子,你带领一个军队,洞洞互联成一棵树,每个洞中有一些bug,要全部杀死这些虫子才可以取得这个洞中的脑子,只有杀死当前节点的bug才可以继续走下去,且如果有0个bug你仍要派遣一个士兵在这里,只不过可以士兵不停留. 题解:很清晰明了的树形dp了,但是某些人说过写题解就要写细致...所以我们还是来详细讲解一下树形dp吧... 树形dp: 这是一个很裸的树形dp,和一般的dp不同的